//mod git;
mod pages;
mod repo;
mod templ_data;

mod project;

use actix_files as fs;
use actix_web::{web, App, HttpRequest, HttpResponse, HttpServer};
use std::io;
use std::path::PathBuf;

#[actix_rt::main]
async fn main() -> io::Result<()> {
    std::env::set_var("RUST_LOG", "actix_server=info,octopus=debug");
    env_logger::init();
    let root = PathBuf::new();

    HttpServer::new(move || {
        App::new()
            .service(fs::Files::new("/static", root.join("static")))
            .service(web::resource("/").route(web::get().to(pages::overview)))
            .service(web::resource("/tree").route(web::get().to(pages::files)))
            .default_service(web::resource("").route(web::get().to(pages::p404)))
    })
    .bind("127.0.0.1:8080")?
    .run()
    .await
}
