//! Overview page
//!
//! This is the first page a user sees when they just go to the site
//! root.  It renders the `README`, or `README.md` file from the modo
//! repo root, to provide users with a starting point.

use crate::templ_data::{overview::Index, BaseData};
use actix_web::{web, HttpRequest, HttpResponse, Result};
use askama::Template;

pub async fn render(req: HttpRequest) -> Result<HttpResponse> {
    let readme: String = markdown::to_html(include_str!("../../fake-readme.md").into());

    let index = Index {
        base: BaseData {
            sitename: "dev.spacekookie.de".into(),
            ..BaseData::default()
        },
        readme,
    }
    .render()
    .unwrap();
    Ok(HttpResponse::Ok().content_type("text/html").body(index))
}
