Title: Part 1: Against Primitivism
Category: Blog
Date: 2019-11-24
Tags: culture, technology, anarchy

This is the first of two blog posts that will be slightly more
philosophical than other texts on my blog.

For some of my regular readers this thesis might not be particularly
radical, but I still feel like it warrants being said.

## What is primitivism?

I think this is the most important question to ask and one that has
many answers. Depending on who you ask, and what their political
background is, the answer might be "a joke", or even "a slur".

In simple terms, primitivism yearns to return to a simpler time,
removing technology from human lives as much as possible. This is
meant to address one of the largest sources of anguish and anxiety in
our modern society, removing it from the equation. In many places
primitivism even frames itself as revolutionary.

The problem with this analysis is that it is inherently linked with
privilege. This can take many forms. A mild form would seek to abolish
the internet, personal computers and phones, arguing that letting
people return to real-life communities will result in more happiness
and a more "natural" life.

This fails to acknowledge that these technologies are life saving for
many, giving both social outcasts and various disabled people a space
to have a community.

But most often it is not those affected who make the case for these
measures. Usually it is white, able bodied men that fail to understand
how their perception of society is skewed because of their own biases.

An even more extreme form of primitivism would reject more general
technological advancements, arguing for things to be "good" because
they are "natural". This analysis, even more so than the last, ignores
challenges that those who propose these solutions don't have to deal
with: what about medicine, what about artificial aids?

## Against the internet

It is true, that in the modern world technology has been turned
against us. Large companies control the way that people interact with
technology, track them, and more. While it is possible to live outside
of this system, only a few people actually do. Even a lot of
technologists (software developers, hackers, ...) don't fully manage
to decouple themselves from the corporately controlled tech
bubble. i.e. how many hackers use Google, Twitter, etc.

On some level it is understandable that the narrative of primitivism
has emerged. This is not to say that these ideas are in any way new,
but in a way they are making a comeback in certain leftist circles.

For someone who doesn't know how to code or has only minor technical
literacy, this fight might seem lost. Approaches like the one
previously outlined seem welcome. I feel it is important to point out
though that the demographic of people coming to this conclusion is
already skewed. More vulnerable people that are dependent on
technology have a different analytical framework and come to radically
different solutions (more on that in a future post)

It is this narrative that inspired these posts, at least in part. I
feel that to proclaim to "blow up the internet" (for example) is lazy
and counter revolutionary at it's core. It frames all conversation
about improving technology and using it in our struggles to liberate
ourselves as regressive, and somehow collaborative with an abusive
system. Suddenly instead of talking about strategy to our solutions
you are thrust to justify your work to people who misunderstand it's
basis and see it as part of the thing you are trying to fight.
    
## Misunderstanding technology

So what do I mean by that, and do I have an example? I'm not trying to
say that someone has to be a programmer to critique technology. I'm
arguing that the same level of engagement people would expect of
someone doing art criticism be extended to tech.

There is this notion that computers are fundamentally flawed, not
because they are fallible and replicate a human's biases, but because
of their foundational inner workings: binary! The sheere fact that
computers operate on the basic assumptions of truths and falsehoods
means that there is to assume to _be_ universal truths.

Not only are conclusions from this hypothesis often shallow and
reductionist, they also misunderstand the performative,
interpretational nature of computers. On the wire every signal is
analog. It is the translation to binary that gives them meaning. But:
this does not mean it is representative of a truth, it is merely a
projection of an assumption. The same way that axioms in mathematics
are not "truths", but rather assumptions to build discoveries on top
of.

The same can be applied to binary data: on the wire all data looks
pretty much the same. Again, it is an interpretation that turns
something into a text or a picture. There is no truth to data, only
relative perspective.

Computers are indeed fallible and as flawed as the humans using
them. But this is precicely because there is no underlying truth to
computing, only the interpretations of those who make the
instructions. This is why I argue that machines are merely an
extention to ourselves rather than any "autonomous" system.

I say "autonomous" (in quotes) systems, because it is another term
that is deeply misunderstood. But this time it is because the creators
of these systems want it to be misunderstood. This is what the next
essay will cover.
